#include "include.h"

extern char *getFile(char *);

ALenum alFormat(wave_t *wave)
{
	if (wave->format->channels = 2)
	{
		if (wave->format->sampleSize == 16)
			return AL_FORMAT_STEREO16;
		else
			return AL_FORMAT_STEREO8;
	}
	else
	{
		if (wave->format->sampleSize == 16)
			return AL_FORMAT_MONO16;
		else
			return AL_FORMAT_MONO8;
	}
}

int checkFormat(char *data, char *format)
{
	return memcmp(&data[8], format, 4);
}

char *findChunk(char *chunk, char *id, int *size, char *end)
{
	while (chunk < end)
	{
		*size = *((int *)(chunk + 4));

		if ( memcmp(chunk, id, 4) == 0 )
			return chunk + 8;
		else
			chunk += *size + 8;
	}
	return NULL;
}

int loadWav(char *file, wave_t *wave)
{
	char	*end;

	wave->file = getFile(file);
	if ( checkFormat(wave->file, "WAVE") )
	{
		printf("Not a wave file.\n");
		return 1;
	}

	end = wave->file + 4 + *((int *)(wave->file + 4));
	wave->format = (waveFormat_t *)findChunk( wave->file + 12, "fmt ", &(wave->dataSize), end);
	wave->pcmData = findChunk( wave->file + 12, "data", &(wave->dataSize), end);
	wave->duration = wave->dataSize / (wave->format->sampleRate * wave->format->channels * (wave->format->sampleSize / 8));
	return 0;
}

void playsound(wave_t *wave)
{
	ALuint		hBuffer[2], hSource[2];

	alGenBuffers(2, hBuffer);
	if (alGetError() != AL_NO_ERROR)
		return;

	alBufferData(hBuffer[0], alFormat(wave), wave->pcmData, wave->dataSize, wave->format->sampleRate);
	if (alGetError() != AL_NO_ERROR)
		return;

	alGenSources(2, hSource);
	if (alGetError() != AL_NO_ERROR)
		return;
	alSourcei(hSource[0], AL_BUFFER, hBuffer[0]);
	if (alGetError() != AL_NO_ERROR)
		return;
	alSourcePlay(hSource[0]);
}
